diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index 4aa5b8ba..3dac0cb6 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -1032,487 +1005,488 @@ define(
 
     onUpdateTreeNode: function(_old, _new, _hierarchy, _opts) {
       var ctx = {
-            b: this, // Browser
-            d: null, // current parent
-            i: null, // current item
-            hasId: true,
-            p: _.toArray(_hierarchy || {}).sort(
-              function(a, b) {
-                return (a.priority === b.priority) ? 0 : (
-                  a.priority < b.priority ? -1 : 1
-                );
+          b: this, // Browser
+          d: null, // current parent
+          i: null, // current item
+          hasId: true,
+          p: _.toArray(_hierarchy || {}).sort(
+          function(a, b) {
+            return (a.priority === b.priority) ? 0 : (
+              a.priority < b.priority ? -1 : 1
+            );
+          }
+        ), // path of the old object
+          pathOfTreeItems: [], // path items
+          t: this.tree, // Tree Api
+          o: _opts,
+          load: true,
+          old: _old,
+          new: _new,
+          op: null,
+        },
+        errorOut = function() {
+          var fail = this.o && this.o.fail;
+          if (fail && typeof(fail) == 'function') {
+            fail.apply(this.t, [this.i, _new, _old]);
+          }
+        }.bind(ctx),
+        deleteNode = function() {
+          var self = this,
+            pathOfTreeItems = this.pathOfTreeItems,
+            findParent = function() {
+              if (pathOfTreeItems.length) {
+                pathOfTreeItems.pop();
+                var length = pathOfTreeItems.length;
+                this.i = (length && pathOfTreeItems[length - 1].item) || null;
+                this.d = (length && pathOfTreeItems[length - 1].d) || null;
+
+                // It is a collection item, let's find the node item
+                if (length && pathOfTreeItems[length - 1].coll) {
+                  pathOfTreeItems.pop();
+                  length = pathOfTreeItems.length;
+                  this.i = (length && pathOfTreeItems[length - 1].item) || null;
+                  this.d = (length && pathOfTreeItems[length - 1].d) || null;
+                }
+              } else {
+                this.i = null;
+                this.d = null;
               }
-            ), // path of the old object
-            pI: [], // path items
-            t: this.tree, // Tree Api
-            o: _opts,
-            load: true,
-            old: _old,
-            new: _new,
-            op: null
-          },
-          errorOut = function() {
-            var fail = this.o && this.o.fail;
-            if (fail && typeof(fail) == 'function') {
-              fail.apply(this.t, [this.i, _new, _old]);
-            }
-          }.bind(ctx),
-          deleteNode = function() {
-            var self = this,
-                pI = this.pI,
-                findParent = function() {
-                  if (pI.length) {
-                    pI.pop();
-                    var length = pI.length;
-                    this.i = (length && pI[length - 1].item) || null;
-                    this.d = (length && pI[length - 1].d) || null;
-
-                    // It is a collection item, let's find the node item
-                    if (length && pI[length - 1].coll) {
-                      pI.pop();
-                      length = pI.length;
-                      this.i = (length && pI[length - 1].item) || null;
-                      this.d = (length && pI[length - 1].d) || null;
+            }.bind(this);
+
+          var _item_parent = (this.i
+            && this.t.hasParent(this.i)
+              && this.t.parent(this.i)) || null,
+            _item_grand_parent = _item_parent ?
+            (this.t.hasParent(_item_parent)
+              && this.t.parent(_item_parent))
+            : null;
+
+          // Remove the current node first.
+          if (
+            this.i && this.d && this.old._id == this.d._id &&
+              this.old._type == this.d._type
+          ) {
+            var _parent = this.t.parent(this.i) || null;
+
+            // If there is no parent then just update the node
+            if(_parent.length == 0 && ctx.op == 'UPDATE') {
+              updateNode();
+            } else {
+              var postRemove = function() {
+                // If item has parent but no grand parent
+                if (_item_parent && !_item_grand_parent) {
+                  var parent = null;
+                  // We need to search in all parent siblings (eg: server groups)
+                  var parents = this.t.siblings(this.i) || [];
+                  parents.push(this.i[0]);
+                  _.each(parents, function (p) {
+                    var d = self.t.itemData($(p));
+                    // If new server group found then assign it parent
+                    if(d._id == self.new._pid) {
+                      parent = p;
+                      self.pathOfTreeItems.push({coll: true, item: parent, d: d});
                     }
-                  } else {
-                    this.i = null;
-                    this.d = null;
-                  }
-                }.bind(this);
+                  });
 
-            var _item_parent = (this.i
-                                    && this.t.hasParent(this.i)
-                                    && this.t.parent(this.i)) || null,
-                _item_grand_parent = _item_parent ?
-                                        (this.t.hasParent(_item_parent)
-                                          && this.t.parent(_item_parent))
-                                        : null;
+                  if (parent) {
+                    this.load = true;
 
-            // Remove the current node first.
-            if (
-              this.i && this.d && this.old._id == this.d._id &&
-              this.old._type == this.d._type
-            ) {
-              var _parent = this.t.parent(this.i) || null;
+                    this.success = function() {
+                      addItemNode();
+                    }.bind(this);
+                    // We can refresh the collection node, but - let's not bother about
+                    // it right now.
+                    this.notFound = errorOut;
+
+                    // var _d = {_id: this.new._pid, _type: self.d._type};
+                    parent = $(parent);
+                    var loaded = this.t.wasLoad(parent),
+                      onLoad = function() {
+                        self.i = parent;
+                        self.d = self.d;
+                        self.pathOfTreeItems.push({coll: false, item: parent, d: self.d});
+                        self.success();
+                        return;
+                      };
 
-              // If there is no parent then just update the node
-              if(_parent.length == 0 && ctx.op == 'UPDATE') {
-                updateNode();
-              } else {
-                var postRemove = function() {
-                  // If item has parent but no grand parent
-                  if (_item_parent && !_item_grand_parent) {
-                    var parent = null;
-                    // We need to search in all parent siblings (eg: server groups)
-                    var parents = this.t.siblings(this.i) || [];
-                    parents.push(this.i[0])
-                    _.each(parents, function (p) {
-                      var d = self.t.itemData($(p));
-                      // If new server group found then assign it parent
-                      if(d._id == self.new._pid) {
-                        parent = p;
-                        self.pI.push({coll: true, item: parent, d: d});
-                      }
-                    });
+                    if (!loaded && self.load) {
+                      self.t.open(parent, {
+                        success: onLoad,
+                        unanimated: true,
+                        fail: function() {
+                          var fail = self && self.o && self.o.fail;
 
-                    if (parent) {
-                      this.load = true;
-
-                      this.success = function() {
-                        addItemNode();
-                      }.bind(this);
-                      // We can refresh the collection node, but - let's not bother about
-                      // it right now.
-                      this.notFound = errorOut;
-
-                      var _d = {_id: this.new._pid, _type: self.d._type}
-                        parent = $(parent);
-                        var loaded = this.t.wasLoad(parent),
-                        onLoad = function() {
-                          self.i = parent;
-                          self.d = self.d;
-                          self.pI.push({coll: false, item: parent, d: self.d});
-                          self.success();
-                          return;
-                        };
-
-                      if (!loaded && self.load) {
-                        self.t.open(parent, {
-                          success: onLoad,
-                            unanimated: true,
-                            fail: function() {
-                              var fail = self && self.o && self.o.fail;
-
-                              if (
-                                fail && typeof(fail) == 'function'
-                              ) {
-                                fail.apply(self.t, []);
-                              }
-                            }
-                          });
-                        } else {
-                          onLoad();
-                        }
-                      }
-                    return;
-                  } else {
-                    // This is for rest of the nodes
-                    var _parentData = this.d;
-                    // Find the grand-parent, or the collection node of parent.
-                    findParent();
-
-                    if (this.i) {
-                      this.load = true;
-
-                      this.success = function() {
-                        addItemNode();
-                      }.bind(this);
-                      // We can refresh the collection node, but - let's not bother about
-                      // it right now.
-                      this.notFound = errorOut;
-
-                      // Find the new parent
-                      this.b._findTreeChildNode(
-                        this.i, {_id: this.new._pid, _type: _parentData._type}, this
-                      );
+                          if (
+                            fail && typeof(fail) == 'function'
+                          ) {
+                            fail.apply(self.t, []);
+                          }
+                        },
+                      });
                     } else {
-                      addItemNode();
+                      onLoad();
                     }
-                    return;
                   }
-                }.bind(this);
+                  return;
+                } else {
+                  // This is for rest of the nodes
+                  var _parentData = this.d;
+                  // Find the grand-parent, or the collection node of parent.
+                  findParent();
 
-                // If there is a parent then we can remove the node
-                this.t.remove(this.i, {
-                  success: function() {
-                    // Find the parent
-                    findParent();
-                    // If server group have no children then close it and set inode
-                    // and unload it so it can fetch new data on next expand
-                    if (_item_parent && !_item_grand_parent && _parent
-                          && self.t.children(_parent).length == 0) {
-                          self.t.setInode(_parent, {
-                            success: function() {
-                              self.t.unload(_parent, {success: function() {
-                                setTimeout(postRemove);
-                              }}
-                              );
-                            }
-                          });
-                    } else {
-                      setTimeout(postRemove);
-                    }
-                    return true;
+                  if (this.i) {
+                    this.load = true;
+
+                    this.success = function() {
+                      addItemNode();
+                    }.bind(this);
+                    // We can refresh the collection node, but - let's not bother about
+                    // it right now.
+                    this.notFound = errorOut;
+
+                    // Find the new parent
+                    this.b._findTreeChildNode(
+                      this.i, {_id: this.new._pid, _type: _parentData._type}, this
+                    );
+                  } else {
+                    addItemNode();
                   }
+                  return;
                 }
+              }.bind(this);
+
+              // If there is a parent then we can remove the node
+              this.t.remove(this.i, {
+                success: function() {
+                  // Find the parent
+                  findParent();
+                  // If server group have no children then close it and set inode
+                  // and unload it so it can fetch new data on next expand
+                  if (_item_parent && !_item_grand_parent && _parent
+                    && self.t.children(_parent).length == 0) {
+                    self.t.setInode(_parent, {
+                      success: function() {
+                        self.t.unload(_parent, {success: function() {
+                          setTimeout(postRemove);
+                        }}
+                          );
+                      },
+                    });
+                  } else {
+                    setTimeout(postRemove);
+                  }
+                  return true;
+                },
+              }
               );
             }
 
+          }
+          errorOut();
+
+        }.bind(ctx),
+        findNewParent = function(_d) {
+          var findParent = function() {
+            var pathOfTreeItems = this.pathOfTreeItems;
+
+            if (pathOfTreeItems.length) {
+              pathOfTreeItems.pop();
+              var length = pathOfTreeItems.length;
+              this.i = (length && pathOfTreeItems[length - 1].item) || null;
+              this.d = (length && pathOfTreeItems[length - 1].d) || null;
+
+              // It is a collection item, let's find the node item
+              if (length && pathOfTreeItems[length - 1].coll) {
+                pathOfTreeItems.pop();
+                length = pathOfTreeItems.length;
+                this.i = (length && pathOfTreeItems[length - 1].item) || null;
+                this.d = (length && pathOfTreeItems[length - 1].d) || null;
+              }
+            } else {
+              this.i = null;
+              this.d = null;
             }
-            errorOut();
-
-          }.bind(ctx),
-          findNewParent = function(_d) {
-            var findParent = function() {
-              if (pI.length) {
-                pI.pop();
-                var length = pI.length;
-                this.i = (length && pI[length - 1].item) || null;
-                this.d = (length && pI[length - 1].d) || null;
+          }.bind(this);
 
-                // It is a collection item, let's find the node item
-                if (length && pI[length - 1].coll) {
-                  pI.pop();
-                  length = pI.length;
-                  this.i = (length && pI[length - 1].item) || null;
-                  this.d = (length && pI[length - 1].d) || null;
-                }
-              } else {
-                this.i = null;
-                this.d = null;
-              }
+          // old parent was not found, can we find the new parent?
+          if (this.i) {
+            this.load = true;
+            this.success = function() {
+              addItemNode();
             }.bind(this);
 
-            // old parent was not found, can we find the new parent?
-            if (this.i) {
-              this.load = true;
-              this.success = function() {
-                addItemNode();
-              }.bind(this);
-
-              if (_d._type == old._type) {
-                // We were already searching the old object under the parent.
-                findParent();
-                _d = this.d;
-                // Find the grand parent
-                findParent();
-              }
-              console.log(_d);
-              _d = this.new._pid;
+            if (_d._type == this.old._type) {
+              // We were already searching the old object under the parent.
+              findParent();
+              _d = this.d;
+              // Find the grand parent
+              findParent();
+            }
+            _d = this.new._pid;
 
-              // We can refresh the collection node, but - let's not bother about
-              // it right now.
-              this.notFound = errorOut;
+            // We can refresh the collection node, but - let's not bother about
+            // it right now.
+            this.notFound = errorOut;
 
-              // Find the new parent
-              this.b._findTreeChildNode(this.i, _d, this);
-            } else {
-              addItemNode();
-            }
-          }.bind(ctx),
-          updateNode = function() {
-            if (
-              this.i && this.d && this.new._type == this.d._type
-            ) {
-              var self = this,
+            // Find the new parent
+            this.b._findTreeChildNode(this.i, _d, this);
+          } else {
+            addItemNode();
+          }
+        }.bind(ctx),
+        updateNode = function() {
+          if (
+            this.i && this.d && this.new._type == this.d._type
+          ) {
+            var self = this,
               _id = this.d._id;
-              if (this.new._id != this.d._id) {
-                // Found the new oid, update its node_id
-                var node_data = this.t.itemData(ctx.i);
-                node_data._id = _id = this.new._id;
-              }
-              if (this.new._id == _id) {
-                // Found the current
-                _.extend(this.d, {
-                  '_id': this.new._id,
-                  '_label': this.new._label,
-                  'label': this.new.label
-                });
-                this.t.setLabel(ctx.i, {label: this.new.label});
-                this.t.addIcon(ctx.i, {icon: this.new.icon});
-                this.t.setId(ctx.i, {id: this.new.id});
-                this.t.openPath(this.i);
-                this.t.deselect(this.i);
-
-                // select tree item after few milliseconds
-                setTimeout(function() {
-                  self.t.select(self.i);
-                }, 10);
-              }
+            if (this.new._id != this.d._id) {
+              // Found the new oid, update its node_id
+              var node_data = this.t.itemData(ctx.i);
+              node_data._id = _id = this.new._id;
             }
-            var success = this.o && this.o.success;
-            if (success && typeof(success) == 'function') {
-              success.apply(this.t, [this.i, _old, _new]);
+            if (this.new._id == _id) {
+              // Found the current
+              _.extend(this.d, {
+                '_id': this.new._id,
+                '_label': this.new._label,
+                'label': this.new.label,
+              });
+              this.t.setLabel(ctx.i, {label: this.new.label});
+              this.t.addIcon(ctx.i, {icon: this.new.icon});
+              this.t.setId(ctx.i, {id: this.new.id});
+              this.t.openPath(this.i);
+              this.t.deselect(this.i);
+
+              // select tree item after few milliseconds
+              setTimeout(function() {
+                self.t.select(self.i);
+              }, 10);
             }
-          }.bind(ctx),
-          traversePath = function() {
-            var ctx = this, i, d;
-
-            ctx.success = traversePath;
-            if (ctx.p.length) {
-              d = ctx.p.shift();
-              // This is the node, we can now do the required operations.
-              // We should first delete the existing node, if the parent-id is
-              // different.
-              if (!ctx.p.length) {
-                if (ctx.op == 'RECREATE') {
-                  ctx.load = false;
-                  ctx.success = deleteNode;
-                  ctx.notFound = findNewParent;
-                } else {
-                  ctx.success = updateNode;
-                  ctx.notFound = errorOut;
-                }
+          }
+          var success = this.o && this.o.success;
+          if (success && typeof(success) == 'function') {
+            success.apply(this.t, [this.i, _old, _new]);
+          }
+        }.bind(ctx),
+        traversePath = function() {
+          var ctx = this, data;
+
+          ctx.success = traversePath;
+          if (ctx.p.length) {
+            data = ctx.p.shift();
+            // This is the node, we can now do the required operations.
+            // We should first delete the existing node, if the parent-id is
+            // different.
+            if (!ctx.p.length) {
+              if (ctx.op == 'RECREATE') {
+                ctx.load = false;
+                ctx.success = deleteNode;
+                ctx.notFound = findNewParent;
+              } else {
+                ctx.success = updateNode;
+                ctx.notFound = errorOut;
               }
-              ctx.b._findTreeChildNode(
-                ctx.i, d, ctx
-              );
-            } else if (ctx.p.length == 1) {
-              ctx.notFound = findNewParent;
             }
-            return true;
-          }.bind(ctx),
-          addItemNode = function() {
-            var ctx = this,
-                first = (ctx.i || this.t.wasLoad(ctx.i)) &&
-                  this.t.first(ctx.i),
-                findChildNode = function(success, notFound) {
-                  var ctx = this;
-                  ctx.success = success;
-                  ctx.notFound = notFound;
-
-                  ctx.b._findTreeChildNode(ctx.i, _new, ctx);
-                }.bind(ctx),
-                selectNode = function() {
-                  this.t.openPath(this.i);
-                  this.t.select(this.i);
-                  if (
-                    ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
-                  ) {
-                    ctx.o.success.apply(ctx.t, [ctx.i, _new]);
+            ctx.b._findTreeChildNode(
+              ctx.i, data, ctx
+            );
+          } else if (ctx.p.length == 1) {
+            ctx.notFound = findNewParent;
+          }
+          return true;
+        }.bind(ctx),
+        addItemNode = function() {
+          var ctx = this,
+            first = (ctx.i || this.t.wasLoad(ctx.i)) &&
+            this.t.first(ctx.i),
+            findChildNode = function(success, notFound) {
+              var ctx = this;
+              ctx.success = success;
+              ctx.notFound = notFound;
+
+              ctx.b._findTreeChildNode(ctx.i, _new, ctx);
+            }.bind(ctx),
+            selectNode = function() {
+              this.t.openPath(this.i);
+              this.t.select(this.i);
+              if (
+                ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
+              ) {
+                ctx.o.success.apply(ctx.t, [ctx.i, _new]);
+              }
+            }.bind(ctx),
+            addNode = function() {
+              var ctx = this,
+                items = ctx.t.children(ctx.i),
+                s = 0, e = items.length - 1, i,
+                linearSearch = function() {
+                  while (e >= s) {
+                    i = items.eq(s);
+                    var d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _new._label
+                      ) == 1
+                    )
+                      return true;
+                    s++;
                   }
-                }.bind(ctx),
-                addNode = function() {
-                  var ctx = this,
-                      items = ctx.t.children(ctx.i),
-                      s = 0, e = items.length - 1, i,
-                      linearSearch = function() {
-                        while (e >= s) {
-                          i = items.eq(s);
-                          var d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _new._label
-                            ) == 1
-                          )
-                            return true;
-                          s++;
-                        }
-                        if (e != items.length - 1) {
-                          i = items.eq(e);
-                          return true;
-                        }
-                        i = null;
-                        return false;
-                      },
-                      binarySearch = function() {
-                        while (e - s > 22) {
-                          i = items.eq(s);
-                          var d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _new._label
-                            ) != -1
-                          )
-                            return true;
-                          i = items.eq(e);
-                          d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _new._label
-                            ) != 1
-                          )
-                            return true;
-                          var m = s + Math.round((e - s) / 2);
-                          i = items.eq(m);
-                          d = ctx.t.itemData(i);
-                          var res = pgAdmin.natural_sort(d._label, _new._label);
-                          if (res == 0)
-                            return true;
-
-                          if (res == -1) {
-                            s = m + 1;
-                            e--;
-                          } else {
-                            s++;
-                            e = m - 1;
-                          }
-                        }
-                        return linearSearch();
-                      };
-
-                  if (binarySearch()) {
-                    ctx.t.before(i, {
-                      itemData: _new,
-                      success: function() {
-                        var new_item = $(arguments[1].items[0]);
-                        ctx.t.openPath(new_item);
-                        ctx.t.select(new_item);
-                        if (
-                          ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
-                        ) {
-                          ctx.o.success.apply(ctx.t, [i, _old, _new]);
-                        }
-                      },
-                      fail: function() {
-                        console.log('Failed to add before..');
-                        if (
-                          ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
-                        ) {
-                          ctx.o.fail.apply(ctx.t, [i, _old, _new]);
-                        }
-                      }
-                    });
-                  } else {
-                    var _appendNode = function() {
-                      ctx.t.append(ctx.i, {
-                        itemData: _new,
-                        success: function() {
-                          var new_item = $(arguments[1].items[0]);
-                          ctx.t.openPath(new_item);
-                          ctx.t.select(new_item);
-                          if (
-                            ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
-                          ) {
-                            ctx.o.success.apply(ctx.t, [ctx.i, _old, _new]);
-                          }
-                        },
-                        fail: function() {
-                          console.log('Failed to append');
-                          if (
-                            ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
-                          ) {
-                            ctx.o.fail.apply(ctx.t, [ctx.i, _old, _new]);
-                          }
-                        }
-                      })
-                    };
-
-                    // If the current node's inode is false
-                    if (ctx.i && !ctx.t.isInode(ctx.i)) {
-                      ctx.t.setInode(ctx.i, {success: _appendNode});
+                  if (e != items.length - 1) {
+                    i = items.eq(e);
+                    return true;
+                  }
+                  i = null;
+                  return false;
+                },
+                binarySearch = function() {
+                  while (e - s > 22) {
+                    i = items.eq(s);
+                    var d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _new._label
+                      ) != -1
+                    )
+                      return true;
+                    i = items.eq(e);
+                    d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _new._label
+                      ) != 1
+                    )
+                      return true;
+                    var m = s + Math.round((e - s) / 2);
+                    i = items.eq(m);
+                    d = ctx.t.itemData(i);
+                    var res = pgAdmin.natural_sort(d._label, _new._label);
+                    if (res == 0)
+                      return true;
+
+                    if (res == -1) {
+                      s = m + 1;
+                      e--;
                     } else {
-                      // Handle case for node without parent i.e. server-group
-                      // or if parent node's inode is true.
-                      _appendNode();
+                      s++;
+                      e = m - 1;
                     }
-
                   }
-                }.bind(ctx);
+                  return linearSearch();
+                };
 
-            // Parent node do not have any children, let me unload it.
-            if (!first && ctx.t.wasLoad(ctx.i)) {
-              ctx.t.unload(ctx.i, {
-                success: function() {
-                  findChildNode(
-                    selectNode,
-                    function() {
-                      var o = this && this.o;
+              if (binarySearch()) {
+                ctx.t.before(i, {
+                  itemData: _new,
+                  success: function() {
+                    var new_item = $(arguments[1].items[0]);
+                    ctx.t.openPath(new_item);
+                    ctx.t.select(new_item);
+                    if (
+                      ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
+                    ) {
+                      ctx.o.success.apply(ctx.t, [i, _old, _new]);
+                    }
+                  },
+                  fail: function() {
+                    console.warn('Failed to add before..', arguments);
+                    if (
+                      ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
+                    ) {
+                      ctx.o.fail.apply(ctx.t, [i, _old, _new]);
+                    }
+                  },
+                });
+              } else {
+                var _appendNode = function() {
+                  ctx.t.append(ctx.i, {
+                    itemData: _new,
+                    success: function() {
+                      var new_item = $(arguments[1].items[0]);
+                      ctx.t.openPath(new_item);
+                      ctx.t.select(new_item);
                       if (
-                        o && o.fail && typeof(o.fail) == 'function'
+                        ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
                       ) {
-                        o.fail.apply(this.t, [this.i, _old, _new]);
+                        ctx.o.success.apply(ctx.t, [ctx.i, _old, _new]);
                       }
-                    }.bind(this)
-                  );
-                }.bind(this),
-                fail: function() {
-                  var o = this && this.o;
-                  if (
-                    o && o.fail && typeof(o.fail) == 'function'
-                  ) {
-                    o.fail.apply(this.t, [this.i, _old, _new]);
-                  }
-                }.bind(this)
-              });
-              return;
-            }
+                    },
+                    fail: function() {
+                      console.warn('Failed to append...', arguments);
+                      if (
+                        ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
+                      ) {
+                        ctx.o.fail.apply(ctx.t, [ctx.i, _old, _new]);
+                      }
+                    },
+                  });
+                };
 
-            // We can find the collection node using _findTreeChildNode
-            // indirectly.
-            findChildNode(selectNode, addNode);
-          }.bind(ctx);
+                // If the current node's inode is false
+                if (ctx.i && !ctx.t.isInode(ctx.i)) {
+                  ctx.t.setInode(ctx.i, {success: _appendNode});
+                } else {
+                  // Handle case for node without parent i.e. server-group
+                  // or if parent node's inode is true.
+                  _appendNode();
+                }
+
+              }
+            }.bind(ctx);
+
+          // Parent node do not have any children, let me unload it.
+          if (!first && ctx.t.wasLoad(ctx.i)) {
+            ctx.t.unload(ctx.i, {
+              success: function() {
+                findChildNode(
+                  selectNode,
+                  function() {
+                    var o = this && this.o;
+                    if (
+                      o && o.fail && typeof(o.fail) == 'function'
+                    ) {
+                      o.fail.apply(this.t, [this.i, _old, _new]);
+                    }
+                  }.bind(this)
+                );
+              }.bind(this),
+              fail: function() {
+                var o = this && this.o;
+                if (
+                  o && o.fail && typeof(o.fail) == 'function'
+                ) {
+                  o.fail.apply(this.t, [this.i, _old, _new]);
+                }
+              }.bind(this),
+            });
+            return;
+          }
+
+          // We can find the collection node using _findTreeChildNode
+          // indirectly.
+          findChildNode(selectNode, addNode);
+        }.bind(ctx);
 
       if (!ctx.t.wasInit() || !_new || !_old) {
         return;
       }
-      ctx.pI.push(_old);
+      ctx.pathOfTreeItems.push(_old);
       _new._label = _new.label;
       _new.label = _.escape(_new.label);
 
       // We need to check if this is collection node and have
       // children count, if yes then add count with label too
       if(ctx.b.Nodes[_new._type].is_collection) {
-          if ('collection_count' in _old && _old['collection_count'] > 0) {
-            _new.label = _.escape(_new._label) +
-                ' <span>(' + _old['collection_count'] + ')</span>'
-          }
+        if ('collection_count' in _old && _old['collection_count'] > 0) {
+          _new.label = _.escape(_new._label) +
+            ' <span>(' + _old['collection_count'] + ')</span>';
+        }
       }
 
       // If server icon/background changes then also we need to re-create it
       if(_old._type == 'server' && _new._type == 'server' &&
-          ( _old._pid != _new._pid ||
-            _old._label != _new._label ||
+        ( _old._pid != _new._pid ||
+          _old._label != _new._label ||
             _old.icon != _new.icon )
       ) {
         ctx.op = 'RECREATE';
